#include <iostream.h>
#include <conio.h>
template <class T>
class Queue
{
    private: T *que;
	     int size;
	     int front;
	     int rear;
    public : Queue(int max = 5);
	     ~Queue()
	     {
		delete [] que;
	     }
	     int addElement(const T&);
	     int deleteElement(T &item);
	     int QFull() const
	     {
		 return rear == size;
	     }
	     int QEmpty() const
	     {
		 return (front >= rear || rear == 0);
	     }
	     void display(void);
}; //End of class template

template <class T>
Queue <T>::Queue(int sz)
{
   size = sz;
   front = 0;
   rear = 0;
   que = new T[size];
}
template <class T>
int Queue <T>:: addElement(const T &element)
{
	if(!QFull())
	{
	    que[rear] = element;
	    rear = rear + 1;
	    return 1;
	}
	else
	    return 0;
}
template <class T>
int Queue <T> :: deleteElement (T &item)
{
    if(!QEmpty())
    {
	 item = que[front];
	 front = front + 1;
	 return 1;
     }
     else
	 return 0;
}
template <class T>
void Queue<T> :: display(void)
{
     if(QEmpty())
     {
	  cout<<"Empty queue"<<endl;
	  return;
     }
     cout<<"Status of the queue is"<<endl;
     for (int i = front; i < rear; i++)
     {
	  cout<<que[i]<<"  ";
     }
     cout<<endl;
}

void main()
{
    Queue <int> IQ(5);
    Queue <double> DQ(5);
    int ival;
    double dval;
    clrscr();
    cout<<"Insert integer elements"<<endl;
    while(!(IQ.QFull()))
    {
	  cin>>ival;
	  IQ.addElement(ival);
    }
    IQ.display();
    cout<<"Queue Full"<<endl;
    cout<<"\nElements are deleted in the order in which they are inserted"<<endl;
    while(!(IQ.QEmpty()))
    {
	  IQ.deleteElement(ival);
	  cout<<ival <<" is deleted"<<endl;
    }
    IQ.display();

    cout<<"Insert double-precision numbers"<<endl;
    while(!(DQ.QFull()))
    {
	  cin>>dval;
	  DQ.addElement(dval);
    }
    DQ.display();
    cout<<"Queue Full"<<endl;
    cout<<"\nDelete elements "<<endl;
    while(!(DQ.QEmpty()))
    {
	  DQ.deleteElement(dval);
	  cout<<dval <<" is deleted"<<endl;
     }
     DQ.display();
}


